Loading...
Searching...
No Matches
crypto_struct.h File Reference

PSA cryptography module: Mbed TLS structured type implementations. More...

`#include "mbedtls/private_access.h"`
`#include "psa/build_info.h"`
`#include "psa/crypto_driver_contexts_primitives.h"`
`#include "psa/crypto_driver_contexts_composites.h"`
`#include "psa/crypto_driver_contexts_key_derivation.h"`
Include dependency graph for crypto_struct.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | psa_hash_operation_s
struct | psa_cipher_operation_s
struct | psa_mac_operation_s
struct | psa_aead_operation_s
struct | psa_key_derivation_s
struct | psa_custom_key_parameters_s
struct | psa_key_production_parameters_s
struct | psa_key_policy_s
struct | psa_key_attributes_s
struct | psa_sign_hash_interruptible_operation_s
| The context for PSA interruptible hash signing. More...
struct | psa_verify_hash_interruptible_operation_s
| The context for PSA interruptible hash verification. More...

## Macros

#define | PSA_HASH_OPERATION_INIT { 0, { 0 } }
#define | PSA_CIPHER_OPERATION_INIT { 0, 0, 0, 0, { 0 } }
#define | PSA_MAC_OPERATION_INIT { 0, 0, 0, { 0 } }
#define | PSA_AEAD_OPERATION_INIT { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, { 0 } }
#define | PSA_KEY_DERIVATION_OPERATION_INIT { 0, 0, 0, { 0 } }
#define | PSA_CUSTOM_KEY_PARAMETERS_INIT { 0 }
#define | PSA_KEY_PRODUCTION_PARAMETERS_INIT { 0 }
#define | PSA_KEY_POLICY_INIT { 0, 0, 0 }
#define | PSA_KEY_BITS_TOO_LARGE ((psa_key_bits_t) -1)
#define | PSA_MAX_KEY_BITS 0xfff8
#define | PSA_KEY_ATTRIBUTES_MAYBE_SLOT_NUMBER
#define | PSA_KEY_ATTRIBUTES_INIT
#define | PSA_SIGN_HASH_INTERRUPTIBLE_OPERATION_INIT { 0, { 0 }, 0, 0 }
#define | PSA_VERIFY_HASH_INTERRUPTIBLE_OPERATION_INIT { 0, { 0 }, 0, 0 }

## Typedefs

typedef struct psa_key_policy_s | psa_key_policy_t
typedef uint16_t | psa_key_bits_t

## Functions

static struct psa_hash_operation_s | psa_hash_operation_init (void)
static struct psa_cipher_operation_s | psa_cipher_operation_init (void)
static struct psa_mac_operation_s | psa_mac_operation_init (void)
static struct psa_aead_operation_s | psa_aead_operation_init (void)
static struct psa_key_derivation_s | psa_key_derivation_operation_init (void)
static struct psa_key_policy_s | psa_key_policy_init (void)
static struct psa_key_attributes_s | psa_key_attributes_init (void)
static void | psa_set_key_id (psa_key_attributes_t *attributes, mbedtls_svc_key_id_t key)
static mbedtls_svc_key_id_t | psa_get_key_id (const psa_key_attributes_t *attributes)
static void | psa_set_key_lifetime (psa_key_attributes_t *attributes, psa_key_lifetime_t lifetime)
static psa_key_lifetime_t | psa_get_key_lifetime (const psa_key_attributes_t *attributes)
static void | psa_extend_key_usage_flags (psa_key_usage_t *usage_flags)
static void | psa_set_key_usage_flags (psa_key_attributes_t *attributes, psa_key_usage_t usage_flags)
static psa_key_usage_t | psa_get_key_usage_flags (const psa_key_attributes_t *attributes)
static void | psa_set_key_algorithm (psa_key_attributes_t *attributes, psa_algorithm_t alg)
static psa_algorithm_t | psa_get_key_algorithm (const psa_key_attributes_t *attributes)
static void | psa_set_key_type (psa_key_attributes_t *attributes, psa_key_type_t type)
static psa_key_type_t | psa_get_key_type (const psa_key_attributes_t *attributes)
static void | psa_set_key_bits (psa_key_attributes_t *attributes, size_t bits)
static size_t | psa_get_key_bits (const psa_key_attributes_t *attributes)
static struct psa_sign_hash_interruptible_operation_s | psa_sign_hash_interruptible_operation_init (void)
static struct psa_verify_hash_interruptible_operation_s | psa_verify_hash_interruptible_operation_init (void)

## Detailed Description

PSA cryptography module: Mbed TLS structured type implementations.

Note
  This file may not be included directly. Applications must include psa/crypto.h.

This file contains the definitions of some data structures with implementation-specific definitions.

In implementations with isolation between the application and the cryptography module, it is expected that the front-end and the back-end would have different versions of this file.

### Design notes about multipart operation structures

For multipart operations without driver delegation support, each multipart operation structure contains a psa_algorithm_t alg field which indicates which specific algorithm the structure is for. When the structure is not in use, alg is 0. Most of the structure consists of a union which is discriminated by alg.

For multipart operations with driver delegation support, each multipart operation structure contains an unsigned int id field indicating which driver got assigned to do the operation. When the structure is not in use, 'id' is 0. The structure contains also a driver context which is the union of the contexts of all drivers able to handle the type of multipart operation.

Note that when alg or id is 0, the content of other fields is undefined. In particular, it is not guaranteed that a freshly-initialized structure is all-zero: we initialize structures to something like {0, 0}, which is only guaranteed to initializes the first member of the union; GCC and Clang initialize the whole structure to 0 (at the time of writing), but MSVC and CompCert don't.

In Mbed TLS, multipart operation structures live independently from the key. This allows Mbed TLS to free the key objects when destroying a key slot. If a multipart operation needs to remember the key after the setup function returns, the operation structure needs to contain a copy of the key.

Definition in file crypto_struct.h.

## Macro Definition Documentation

## PSA_CUSTOM_KEY_PARAMETERS_INIT

#define PSA_CUSTOM_KEY_PARAMETERS_INIT { 0 }

The default production parameters for key generation or key derivation.

Calling psa_generate_key_custom() or psa_key_derivation_output_key_custom() with custom=PSA_CUSTOM_KEY_PARAMETERS_INIT and custom_data_length=0 is equivalent to calling psa_generate_key() or psa_key_derivation_output_key() respectively.

Definition at line 238 of file crypto_struct.h.

## PSA_KEY_ATTRIBUTES_MAYBE_SLOT_NUMBER

#define PSA_KEY_ATTRIBUTES_MAYBE_SLOT_NUMBER

Definition at line 321 of file crypto_struct.h.

## PSA_KEY_BITS_TOO_LARGE

#define PSA_KEY_BITS_TOO_LARGE ((psa_key_bits_t) -1)

Definition at line 287 of file crypto_struct.h.

Referenced by psa_set_key_bits().

## PSA_KEY_POLICY_INIT

#define PSA_KEY_POLICY_INIT { 0, 0, 0 }

Definition at line 275 of file crypto_struct.h.

Referenced by psa_key_policy_init().

## PSA_KEY_PRODUCTION_PARAMETERS_INIT

#define PSA_KEY_PRODUCTION_PARAMETERS_INIT { 0 }

The default production parameters for key generation or key derivation.

Calling psa_generate_key_ext() or psa_key_derivation_output_key_ext() with params=PSA_KEY_PRODUCTION_PARAMETERS_INIT and params_data_length == 0 is equivalent to calling psa_generate_key() or psa_key_derivation_output_key() respectively.

Definition at line 265 of file crypto_struct.h.

## PSA_MAX_KEY_BITS

#define PSA_MAX_KEY_BITS 0xfff8

Definition at line 293 of file crypto_struct.h.

Referenced by psa_set_key_bits().

## PSA_SIGN_HASH_INTERRUPTIBLE_OPERATION_INIT

#define PSA_SIGN_HASH_INTERRUPTIBLE_OPERATION_INIT { 0, { 0 }, 0, 0 }

Definition at line 473 of file crypto_struct.h.

Referenced by psa_sign_hash_interruptible_operation_init().

## PSA_VERIFY_HASH_INTERRUPTIBLE_OPERATION_INIT

#define PSA_VERIFY_HASH_INTERRUPTIBLE_OPERATION_INIT { 0, { 0 }, 0, 0 }

Definition at line 511 of file crypto_struct.h.

Referenced by psa_verify_hash_interruptible_operation_init().

## Typedef Documentation

## psa_key_bits_t

typedef uint16_t psa_key_bits_t

Definition at line 284 of file crypto_struct.h.

## psa_key_policy_t

typedef struct psa_key_policy_s psa_key_policy_t

Definition at line 273 of file crypto_struct.h.

## Function Documentation

## psa_aead_operation_init()

struct psa_aead_operation_s psa_aead_operation_init | ( | void |  | ) |

inline static

Definition at line 192 of file crypto_struct.h.

References PSA_AEAD_OPERATION_INIT, and psa_aead_operation_init().

## psa_cipher_operation_init()

struct psa_cipher_operation_s psa_cipher_operation_init | ( | void |  | ) |

inline static

Definition at line 121 of file crypto_struct.h.

References PSA_CIPHER_OPERATION_INIT, and psa_cipher_operation_init().

## psa_extend_key_usage_flags()

void psa_extend_key_usage_flags | ( | psa_key_usage_t * | usage_flags | ) |

inline static

Definition at line 383 of file crypto_struct.h.

References PSA_KEY_USAGE_SIGN_HASH, PSA_KEY_USAGE_SIGN_MESSAGE, PSA_KEY_USAGE_VERIFY_HASH, and PSA_KEY_USAGE_VERIFY_MESSAGE.

Referenced by psa_set_key_usage_flags().

## psa_get_key_algorithm()

psa_algorithm_t psa_get_key_algorithm | ( | const psa_key_attributes_t * | attributes | ) |

inline static

Definition at line 413 of file crypto_struct.h.

## psa_get_key_bits()

size_t psa_get_key_bits | ( | const psa_key_attributes_t * | attributes | ) |

inline static

Definition at line 441 of file crypto_struct.h.

## psa_get_key_id()

mbedtls_svc_key_id_t psa_get_key_id | ( | const psa_key_attributes_t * | attributes | ) |

inline static

Definition at line 350 of file crypto_struct.h.

## psa_get_key_lifetime()

psa_key_lifetime_t psa_get_key_lifetime | ( | const psa_key_attributes_t * | attributes | ) |

inline static

Definition at line 377 of file crypto_struct.h.

## psa_get_key_type()

psa_key_type_t psa_get_key_type | ( | const psa_key_attributes_t * | attributes | ) |

inline static

Definition at line 425 of file crypto_struct.h.

## psa_get_key_usage_flags()

psa_key_usage_t psa_get_key_usage_flags | ( | const psa_key_attributes_t * | attributes | ) |

inline static

Definition at line 401 of file crypto_struct.h.

## psa_hash_operation_init()

struct psa_hash_operation_s psa_hash_operation_init | ( | void |  | ) |

inline static

Definition at line 89 of file crypto_struct.h.

References PSA_HASH_OPERATION_INIT, and psa_hash_operation_init().

## psa_key_attributes_init()

struct psa_key_attributes_s psa_key_attributes_init | ( | void |  | ) |

inline static

Definition at line 329 of file crypto_struct.h.

References PSA_KEY_ATTRIBUTES_INIT, and psa_key_attributes_init().

## psa_key_derivation_operation_init()

struct psa_key_derivation_s psa_key_derivation_operation_init | ( | void |  | ) |

inline static

Definition at line 219 of file crypto_struct.h.

References PSA_KEY_DERIVATION_OPERATION_INIT, and psa_key_derivation_operation_init().

## psa_key_policy_init()

struct psa_key_policy_s psa_key_policy_init | ( | void |  | ) |

inline static

Definition at line 276 of file crypto_struct.h.

References PSA_KEY_POLICY_INIT, and psa_key_policy_init().

Referenced by psa_key_policy_init().

## psa_mac_operation_init()

struct psa_mac_operation_s psa_mac_operation_init | ( | void |  | ) |

inline static

Definition at line 153 of file crypto_struct.h.

References PSA_MAC_OPERATION_INIT, and psa_mac_operation_init().

## psa_set_key_algorithm()

void psa_set_key_algorithm | ( | psa_key_attributes_t * | attributes,
|  | psa_algorithm_t | alg )

inline static

Definition at line 407 of file crypto_struct.h.

## psa_set_key_bits()

void psa_set_key_bits | ( | psa_key_attributes_t * | attributes,
|  | size_t | bits )

inline static

Definition at line 431 of file crypto_struct.h.

References PSA_KEY_BITS_TOO_LARGE, and PSA_MAX_KEY_BITS.

## psa_set_key_id()

void psa_set_key_id | ( | psa_key_attributes_t * | attributes,
|  | mbedtls_svc_key_id_t | key )

inline static

Definition at line 335 of file crypto_struct.h.

References PSA_KEY_LIFETIME_FROM_PERSISTENCE_AND_LOCATION, PSA_KEY_LIFETIME_GET_LOCATION, PSA_KEY_LIFETIME_IS_VOLATILE, and PSA_KEY_LIFETIME_PERSISTENT.

## psa_set_key_lifetime()

void psa_set_key_lifetime | ( | psa_key_attributes_t * | attributes,
|  | psa_key_lifetime_t | lifetime )

inline static

Definition at line 364 of file crypto_struct.h.

References PSA_KEY_LIFETIME_IS_VOLATILE.

## psa_set_key_type()

void psa_set_key_type | ( | psa_key_attributes_t * | attributes,
|  | psa_key_type_t | type )

inline static

Definition at line 419 of file crypto_struct.h.

## psa_set_key_usage_flags()

void psa_set_key_usage_flags | ( | psa_key_attributes_t * | attributes,
|  | psa_key_usage_t | usage_flags )

inline static

Definition at line 394 of file crypto_struct.h.

References psa_extend_key_usage_flags().

## psa_sign_hash_interruptible_operation_init()

struct psa_sign_hash_interruptible_operation_s psa_sign_hash_interruptible_operation_init | ( | void |  | ) |

inline static

Definition at line 477 of file crypto_struct.h.

References PSA_SIGN_HASH_INTERRUPTIBLE_OPERATION_INIT, and psa_sign_hash_interruptible_operation_init().

Referenced by psa_sign_hash_interruptible_operation_init().

## psa_verify_hash_interruptible_operation_init()

struct psa_verify_hash_interruptible_operation_s psa_verify_hash_interruptible_operation_init | ( | void |  | ) |

inline static

Definition at line 515 of file crypto_struct.h.

References PSA_VERIFY_HASH_INTERRUPTIBLE_OPERATION_INIT, and psa_verify_hash_interruptible_operation_init().

Referenced by psa_verify_hash_interruptible_operation_init().